import parser._
import fun._
val pref = ProgFun.parse(
  """
    let r = ref 0 in
      r := !r + 1;
      r := !r + 1;
      !r
    end
  """)
eval(pref)
val pref2 = ProgFun.parse(
"""
  let r = ref 0 in
    (r := !r + 1; !r) + (r := !r + 1; !r)
  end
""")
eval(pref2)
val preffun = ProgFun.parse(
"""
fun f(a, b, c)
  a - b - c
end

let r = ref 0 in
  f((r := !r + 1; !r),
    (r := !r + 1; throw "erro aqui"; !r),
    (r := !r + 1; !r))
end
""")
eval(preffun) // avalia args da direita pra esquerda
val prefref = ProgFun.parse(
"""
  let c = ref 0 in
    (c := !c + 1; c) := !c + 1
  end
""".stripMargin
)
eval(prefref)
val pderef = ProgFun.parse(
"""
  let c = ref 0 in
    !(c := 1; c)
  end
""".stripMargin
)
eval(pderef)
val pthrow = ProgFun.parse(
  """
fun f(a, b, c)
  a - b - c
end
try
  let r = ref 0 in
    try
      f((r := !r + 1; !r),
        (r := !r + 1; throw "erro aqui"; !r),
        (r := !r + 1; !r))
    finally
      r := 0
    end
  end
catch
  let r = ref 1 in
    throw "erro aqui de novo"
  end
finally
  throw "erro no finally"
end
  """)
eval(pthrow) // avalia args da direita pra esquerda

val pcur = ProgFun.parse(
  """
fun curry_mul(x)
  fun (y)
    x * y
  end
end

let x = 2 in (curry_mul(5))(3) end
  """)
eval(pcur)

val pcont = ProgFun.parse(
  """
fun cont()
  let n = ref 0 in
    fun ()
      n := !n + 1;
      !n
    end
   end
end

let c1 = cont(), c2 = cont() in
  (c1)();
  (c1)();
  (c2)();
  (c1)() + (c2)()
end
  """
)
eval(pcont)

val pfree = ProgFun.parse(
  """
let f = fun (a) if a < 10 then a else y end end in
  let y = 2 in (f)(y) end
end
  """
)
eval(pfree)

val pcbn = ProgFun.parse(
  """
fun loop()
  loop()
end

let _a = loop() in
let _b = if true then 4 else _a end in
  -- _b é FunV(_a: FunV(Map(), List(), loop()), List(), _a)
  if false then 2 else _b end
end
end
  """
)
eval(pcbn)

val p5 = ProgFun.parse(
  """
    letrec fat = fun (x)
      if x < 2 then
        x
      else
        x * (fat)(x - 1)
      end
    end in
      (fat)(5)
    end
  """)
eval(p5)

val pcoro2 = ProgFun.parse(
  """
fun Coroutine(link, resumer, yielder)
  fun (f)
    (f)(link, resumer, yielder)
  end
end

let CORO_ATUAL = ref ref 0, -- usado no yield
    coro = fun (k, f)
             (k)(ref Coroutine(ref 0, fun (v) (f)(fun (v) throw "gerador terminou" end) end,
                                      fun (v) throw "gerador não começou" end))
           end,
    resume = fun (k, c)
               (!c)(fun (link, resumer, yielder)
                      c := Coroutine(!CORO_ATUAL, fun (v) throw "gerador em execução" end, k);
                      CORO_ATUAL := c;
                      (resumer)(0)
                    end)
             end,
    yield = fun (k, v)
               (!!CORO_ATUAL)(fun (link, resumer, yielder)
                               !CORO_ATUAL := Coroutine(0, k, fun (v) throw "gerador não começou" end);
                               CORO_ATUAL := link;
                               (yielder)(v)
                             end)
            end in

letrec gen_helper = fun (k, n)
                      (yield)(fun (v) (gen_helper)(k, n - 1) end, n)
                    end in
(coro)(fun (c)
  (resume)(fun (v1)
     (resume)(fun (v2)
       (resume)(fun (v3)
                 v1 + v2 + v3
              end, c) end, c) end, c)
end, fun (k) (gen_helper)(k, 10) end)
end
end
"""
)
eval(pcoro2)
