import parser._
import microc._

val pfunat = ProgFun.parse(
  """
fun f(a, b, c)
  a := a + b * c;
  a
end
f(2, 3, 5)
  """)
eval(pfunat)
val pref = ProgFun.parse(
  """
fun troca(a, b)
  let tmp = *a in
    *a := *b; -- *(*l) := *b, onde l é o endereço de a, que é *(&x) := *b
    *b := tmp
  end
end
let x = 1, y = 2 in
  --try
    troca(&x, &y); -- troca(&(*l1), &(*l2)), onde l1 é o endereço de x e l2 o de y
    x - y
  --catch
  --  x - y
  --end
end + let a = 3, b = 4 in
  a + b
end
  """)
eval(pref)
val psoma = ProgFun.parse("2 + 3 * 5")
eval(psoma)
val pfun = ProgFun.parse(
  """
fun f(a, b, c)
  a + b * c
end
f(2, 3, 5)
  """)
eval(pfun)
val pend = ProgFun.parse(
  """
    *5 := 2 + 2;
    *5
  """)
eval(pend)
val pvet = ProgFun.parse(
  """
fun soma(vet, len)
  if len < 1 then
    0
  else
    *vet + soma(vet + 1, len - 1)
  end
end

let vet = 1000 in
  *1000 := 2;
  *(1000 + 1) := 4;
  *(1000 + 2) := 6;
  soma(vet, 3)
end
  """)
eval(pvet)

val ppref = ProgFun.parse(
  """
fun troca(_a, _b)
  let tmp = _a in
    _a := _b; -- *l1 := *l2
    _b := tmp
  end
end

let x = 1, y = 2 in
  troca(x, y); -- troca(*l1, *l2), onde l1 é o endereço de x e l2 o de y
  x - y
end + let a = 3, b = 4 in
  a + b
end
  """)
eval(ppref)


val pcont = ProgFun.parse(
  """
fun anon(env)
  *env := *env + 1;
  *env
end

fun cont()
  let clos = *100 in
    *(clos + 0) := 0;
    *100 := *100 + 1;
    clos
  end
end

*100 := 1000;
let c1 = cont(), c2 = cont() in
   anon(c1);
   anon(c1);
   anon(c2);
   anon(c1) + anon(c2)
end
  """
)
eval(pcont)

val pcoro = ProgFun.parse(
  """
fun gen()
  let n = 10 in
    while 0 < n do
      yield n;
      n := n - 1
    end
  end
end

let c = coro gen in
  resume c +
  resume c +
  resume c
end
  """
)
eval(pcoro)

val pcoro2 = ProgFun.parse(
  """
fun gen_helper(n)
  yield n;
  gen_helper(n - 1)
end

fun gen()
  gen_helper(10)
end

let c = coro gen in
  resume c +
  resume c +
  resume c
end
  """
)
eval(pcoro2)

